#ifndef XMEDIA_H
#define XMEDIA_H

#include <QtGui/QMainWindow>
#include <QtGui/QButtonGroup>
#include <QtGui/QListWidget>
#include <QtGui/QMainWindow>
#include <QtGui/QWidget>
#include "xui.h"
#include "xmedia_home.h"
#include "xmedia_music.h"
#include "xmedia_system.h"
#include "xmedia_stream.h"

#define XMEDIA_MAX_MENU_ITEMS 8

namespace Ui
{
    class xMediaClass;
}

class xMedia : public QMainWindow
{
    Q_OBJECT

public:
    xMedia(QWidget *parent = 0);
    ~xMedia();
    int scrollToItem(int relative);

private slots:
    void commandInfoReceived(unsigned char command, unsigned char length, unsigned char *data );
    void commandPowerManagmentReceived(unsigned char command, unsigned char length, unsigned char *data );
    void commandUserInterfaceReceived(unsigned char command, unsigned char length, unsigned char *data );
    void commandMouseEmulationReceived(unsigned char command, unsigned char length, unsigned char *data );
    void transmissionError(xsieError);
    void itemHighlighted(QListWidgetItem *mitem, QListWidgetItem* prev);
    void itemSelected(QListWidgetItem *mitem);

private:
    Ui::xMediaClass *ui;
    int ItemPosition;
    xui UserInterface;
    xmedia_system *system;

};

#endif // XMEDIA_H
