#ifndef XMEDIA_CONFIG_H
#define XMEDIA_CONFIG_H

#include <QObject>
#include <QSettings>
#include <QStringList>

typedef struct
{
    bool dhcp;
    QString address;
    QString subnet;
    QString gateway;
    QString dns;
} xMediaConfigNetworks;

typedef struct
{
    int index;
    QString address;
    QString name;
} xMediaConfigStations;

typedef struct
{
    int index;
    QString address;
    QString name;
} xMediaConfigShares;

class xmedia_config : public QObject
{
public:
    xmedia_config();
    ~xmedia_config();

    void save();
    void reload();

    void setParameter(QString name, QString value);
    QString getParameter(QString name);

    QList<xMediaConfigNetworks> networks;
    QList<xMediaConfigStations> stations;
    QList<xMediaConfigShares> shares;

private:
    QMap<QString, QString> Parameters;
    QSettings *Settings;
};

#endif // XMEDIA_CONFIG_H
