#ifndef XMEDIA_FILEBROWSER_H
#define XMEDIA_FILEBROWSER_H

#include <QDir>
#include <QtGui/QListWidget>

#define XMEDIA_FILEBROWSER_TOP_PATH QString("/home/xMedia/Files")

class xmedia_filebrowser : public QListWidget
{
    Q_OBJECT

    public:
        xmedia_filebrowser(QWidget *parent = 0, const QString &filter = "");
        void setDir(const QString &path, const QString &selected = "");
        void setFilter(const QString &filter);
        int selectNextMediaFile();
        int selectPreviousMediaFile();
        int scrollToItemAndCenter(int relative);
        bool directoryUp();
        void pickCurrentItem();

    signals:
        void picked(const QString &fileName);

    private slots:
        void itemHighlighted(QListWidgetItem *mitem, QListWidgetItem* prev);
        void itemSelected(QListWidgetItem *mitem);

    private:
        QString nameFilter;
        QString basePath;
};

#endif // XMEDIA_FILEBROWSER_H
