#ifndef XMEDIA_MUSIC_H
#define XMEDIA_MUSIC_H

#include <QtGui/QDialog>
#include <QProcess>
#include <QtGui>
#include "xmplayer.h"

namespace Ui {
    class xmedia_music;
}

class xmedia_music : public QDialog {
    Q_OBJECT
    Q_DISABLE_COPY(xmedia_music)
public:
    explicit xmedia_music(QWidget *parent = 0);
    virtual ~xmedia_music();
    void startPlayback(QString file = "");
    void startStopPlayback();
    void startPlayback();
    void stopPlayback();
    void volumeSet(int relative_volume);

public slots:
    void commandUserInterfaceReceived(unsigned char command, unsigned char length, unsigned char *data );

protected:
    virtual void changeEvent(QEvent *e);

private slots:
    void progressChanged(xMPlayerProgress progress);
    void stateChanged(bool playing);
    void fileChanged(xMPlayerFileInfo);
    void finished(QString filename);
    void filePicked(const QString &file);

private:
    void userInterfaceBrowser(unsigned char command);
    void userInterfaceMusicPlayer(unsigned char command);
    void userInterfaceVideoPlayer(unsigned char command);
    void userInterfaceVolume(unsigned char command);

    void gotoBrowser();
    void gotoPlayer();
    void gotoVolume();

    Ui::xmedia_music *m_ui;
    xMplayer *player;
    QProcess *proc;
    QProcess *volume_proc;
    qint64 totalTime;
    int volume;
};

#endif // XMEDIA_MUSIC_H
