#ifndef XMEDIA_STREAM_H
#define XMEDIA_STREAM_H

#include <QtGui/QDialog>
#include <QProcess>
#include <QtGui>
#include "xmplayer.h"

typedef enum
{
    XMEDIA_STREAM_BUFFERING,
    XMEDIA_STREAM_PLAYING,
    XMEDIA_STREAM_PAUSED,
    XMEDIA_STREAM_ENDED
} XMEDIA_STREAM_STATUS;


namespace Ui {
    class xmedia_stream;
}

class xmedia_stream : public QDialog {
    Q_OBJECT
    Q_DISABLE_COPY(xmedia_stream)
public:
    explicit xmedia_stream(QWidget *parent = 0);
    virtual ~xmedia_stream();
    void startPlayback(QString file = "");
    void startStopPlayback();
    void startPlayback();
    void stopPlayback();
    void volumeSet(int relative_volume);

public slots:
    void commandUserInterfaceReceived(unsigned char command, unsigned char length, unsigned char *data );

protected:
    virtual void changeEvent(QEvent *e);

private slots:
    void progressChanged(xMPlayerProgress progress);
    void stateChanged(bool playing);
    void fileChanged(xMPlayerFileInfo);
    void finished(QString filename);
    void filePicked(const QString &file);

private:
    void userInterfaceBrowser(unsigned char command);
    void userInterfaceMusicPlayer(unsigned char command);
    void userInterfaceVideoPlayer(unsigned char command);

    void gotoBrowser();
    void gotoPlayer();

    void setStatus(XMEDIA_STREAM_STATUS status);

    Ui::xmedia_stream *m_ui;
    xMplayer *player;
    QProcess *volume_proc;
    qint64 totalTime;
    int volume;
};

#endif // XMEDIA_MUSIC_H
