#include "xmedia_system.h"
#include <iostream>
using namespace std;


xmedia_system::xmedia_system()
{
    this->SDCardMounted = false;

}

void xmedia_system::run()
{
    this->mountInternalMemory();
    this->startUsbSupport();
    this->startSambaServer();
    this->mountNetworkShares();

    while(true)
    {
        if(QFileInfo("/dev/mmcblk1p1").exists())
        {
            this->mountSDCard();
        }
        else
        {
            this->unmoutSDCard();
        }

        this->msleep(500);
        emit this->timeUpdated(QTime::currentTime(), QDate::currentDate());
    }
}

void xmedia_system::mountSDCard()
{
    if(!SDCardMounted)
    {
        cout<<"MMCBLK1 present, mounting..."<<endl;
        this->getProcessResult("mount /dev/mmcblk1p1 /home/xMedia/Files/SD/");
        this->stopUsbSupport();
        this->SDCardMounted = true;
        this->startUsbSupport();
    }
}
void xmedia_system::unmoutSDCard()
{
    if(SDCardMounted)
    {
        cout<<"MMCBLK1 not present, unmounting..."<<endl;
        this->getProcessResult("umount /dev/mmcblk1p1");
        this->stopUsbSupport();
        this->SDCardMounted = false;
        this->startUsbSupport();
    }
}

void xmedia_system::startSambaServer()
{
    cout<<"Starting Samba Server!"<<endl;
    this->getProcessResult("./startSmb start");
}

void xmedia_system::startUsbSupport()
{
    cout<<"Starting USB Support!"<<endl;
    if(SDCardMounted)
    {
        this->getProcessResult("modprobe g_file_storage file=/dev/mmcblk1,/dev/mmcblk0p3 removable=1");
    }
    else
    {
        this->getProcessResult("modprobe g_file_storage file=/dev/mmcblk0p3 removable=1");
    }
}

void xmedia_system::stopUsbSupport()
{
    cout<<"Stopping USB Support!"<<endl;
    this->getProcessResult("rmmod g_file_storage");
}



void xmedia_system::mountInternalMemory()
{
    cout<<"Mounting Internal Memory!"<<endl;
    this->getProcessResult("mount /dev/mmcblk0p3 /home/xMedia/Files/Internal");
}

void xmedia_system::mountNetworkShares()
{
    xmedia_config *config = new xmedia_config();

    for(int i = 0; i < config->shares.size(); i++)
    {
        QString path = "/home/xMedia/Files/Network/" + config->shares[i].name;
        cout<<"Mounting Share:"<<qPrintable(path)<<" from "<<qPrintable(config->shares[i].address)<<endl;
        this->getProcessResult("mkdir \"" + path + "\"");
        this->getProcessResult("mount -t cifs " + config->shares[i].address + " -o username=guest \"" + path + "\"");
    }

    delete config;
}

QString xmedia_system::getProcessResult(QString process)
{
    QString data = "";
    QProcess *proc = new QProcess();
    proc->start(process);
    proc->waitForFinished(30000);
    while(proc->canReadLine())
    {
        data += proc->readLine();
    }
    delete proc;

    return data;
}
