#include "xui.h"
#include <stdio.h>

xui::xui() : QObject()
{
    qRegisterMetaType<xsieError>("xsieError");
    qRegisterMetaType<xsiePacket>("xsiePacket");

    connect(&SerialEngine, SIGNAL(packetReceived(xsiePacket)),
            this, SLOT(packetReceived(xsiePacket)));
    connect(&SerialEngine, SIGNAL(dataError(xsieError)),
            this, SLOT(errorReceived(xsieError)));

    SerialEngine.start();
}

void xui::sendCommand(unsigned char command, char *data, unsigned char length)
{
    xsiePacket packet;

    packet.command = command;
    memcpy(packet.data, data, length);
    packet.length = length;

    SerialEngine.submitPacket(packet);
}


void xui::packetReceived(xsiePacket data)
{
    if(data.command < 0x10) //Control commands
    {
    }
    else if(data.command < 0x20) //Info commands
    {
        commandInfoReceived(data.command, data.length, data.data);
    }
    else if(data.command < 0x30) //Power Management commands
    {
        commandPowerManagmentReceived(data.command, data.length, data.data);
    }
    else if(data.command < 0x50) //UserInterface commands
    {
        commandUserInterfaceReceived(data.command, data.length, data.data);
    }
    else if(data.command < 0x60) //MouseEmulation commands
    {
        commandMouseEmulationReceived(data.command, data.length, data.data);
    }
}
void xui::errorReceived(xsieError error)
{

}
