#ifndef XUI_H
#define XUI_H

#include <QThread>
#include <QObject>
#include <QtGui/QAction>
#include "xsie.h"

#define XUI_OK 0x31
#define XUI_BACK 0x32
#define XUI_GP1 0x33
#define XUI_GP2 0x34
#define XUI_LEFT 0x35
#define XUI_RIGHT 0x36
#define XUI_4WAY_UP 0x37
#define XUI_4WAY_DOWN 0x38
#define XUI_4WAY_LEFT 0x39
#define XUI_4WAY_RIGHT 0x3A

class xui : public QObject
{
    Q_OBJECT

    public:
        xui();
        void sendCommand(unsigned char command, char *data, unsigned char length);

    signals:
        void commandInfoReceived(unsigned char command, unsigned char length, unsigned char *data );
        void commandPowerManagmentReceived(unsigned char command, unsigned char length, unsigned char *data );
        void commandUserInterfaceReceived(unsigned char command, unsigned char length, unsigned char *data );
        void commandMouseEmulationReceived(unsigned char command, unsigned char length, unsigned char *data );
        void transmissionError(xsieError);

    private slots:
        void packetReceived(xsiePacket);
        void errorReceived(xsieError);

    private:
        xsie SerialEngine;
};

#endif // XUI_H
